export interface useAuth {
  login(authCode: string): Promise<void>
  logout(): Promise<void>
  isAuthenticated(): Promise<boolean>
}


export default () => {
  return {
    isAuthenticated: async (): Promise<boolean> => {
      return $fetch('/api/userinfo')
        .then(() => true)
        .catch(() => false)
    },

    login: async (authCode: string): Promise<void> => {
      if (authCode.length != 6) {
        throw Error('login failed')
      }
      const resp = await $fetch(`/api/login?code=${authCode}`)
      if (resp !== 'ok') {
        throw Error('login failed')
      }
    },

    logout: async (): Promise<void> => {
      await $fetch('/api/logout')
    },
  }
}
